local ADDON = ...

local UPDATEPERIOD, elapsed = 0.2, 0
local speed
local string_format = string.format
local locX, locY, mapID
local ShowCoord = false

local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject(ADDON, {
	type = "data source",
	icon = "Interface\\Addons\\"..ADDON.."\\icon.tga",
	text = "-"
})

dataobj.OnClick = function(self, button)  

	if 		button == "RightButton" then ToggleFrame(WorldMapFrame)   
	
	elseif 	button == "LeftButton" then ShowCoord = not ShowCoord

	elseif 	button == "MiddleButton" then ToggleBattlefieldMap()	
		
	end
	
end

local frame_ms = CreateFrame("Frame", ADDON.."_LDB")
frame_ms:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	
	if ShowCoord == true then
	
		local mapID = C_Map.GetBestMapForUnit("player")
		
		if mapID then
			local mapPos = C_Map.GetPlayerMapPosition(mapID, "player")
			if mapPos then
				locX, locY = mapPos:GetXY()
			end
		else
			locX = "0"
			locY = "0"
		end
		dataobj.text = string_format("%.1f %.1f", locX*100,locY*100)
	else 
		speed = (GetUnitSpeed("Player") / 7) * 100
		dataobj.text = string_format("%.1f", speed)
	end

end)

function dataobj.OnTooltipShow(tooltip)

	tooltip:AddDoubleLine(ADDON, "", 1,1,0,1,1,1)
	tooltip:AddLine(" ")
	tooltip:AddDoubleLine("Middle Click", "Toggle ZoneMap", 	0,1,0,1,1,0)
	tooltip:AddDoubleLine("Right Click", "Toggle WorldMap", 	0,1,0,1,1,0)
	tooltip:AddDoubleLine("Left Click", "Toggle LDB display", 	0,1,0,1,1,0)

end